////////////////////////////////////////////////////////////////////////
// 3Dstars02.c
// 3D Star Field
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

unsigned char GetMode0PixelColorByte(unsigned char nColor, unsigned char nPixel)
{
	unsigned char nByte = 0;

	if(nPixel == 0)
	{
		nByte &= 85;

		if(nColor & 1)
			nByte |= 128;

		if(nColor & 2)
			nByte |= 8;

		if(nColor & 4)
			nByte |= 32;

		if(nColor & 8)
			nByte |= 2;
	}
	else
	{
		nByte &= 170;

		if(nColor & 1)
			nByte |= 64;

		if(nColor & 2)
			nByte |= 4;

		if(nColor & 4)
			nByte |= 16;

		if(nColor & 8)
			nByte |= 1;
	}

	return nByte;
}

unsigned char *GetLineAddress(unsigned char nLine)
{
	return (unsigned char *)0xC000 + ((nLine / 8) * 80) + ((nLine % 8) * 2048);
}

////////////////////////////////////////////////////////////////////////
unsigned char char1,char2,char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}
////////////////////////////////////////////////////////////////////////

#define MAX_Z 64
#define ORIGIN_X 80
#define ORIGIN_Y 100

struct _tStar
{
	unsigned char nColor;
	unsigned char nActualAddress;
	unsigned char *aAddress[MAX_Z + 1];
};

#define STARS_NUM 25
struct _tStar aStars[STARS_NUM];

void main()
{
	unsigned int nFPS = 0;
	unsigned int nTimeLast = 0;
	unsigned char nStar = 0;
	unsigned char nAddress = 0;
	struct _tStar *pStar = NULL;
	int nScreenX = 0;
	int nScreenY = 0;

	memset(aStars, 0, sizeof(aStars));
	
	//SCR_SET_MODE 0
	__asm
		ld a, #0
		call #0xBC0E
	__endasm;

	//PALETE
	__asm
		ld a, #0
		ld b, #0 ;black
		ld c, b
		call #0xBC32 ;SCR SET INK

		ld a, #1
		ld b, #12 ;Yellow
		ld c, b
		call #0xBC32 ;SCR SET INK

		ld a, #2
		ld b, #25 ;Pastel Yellow		
		ld c, b
		call #0xBC32 ;SCR SET INK

		ld a, #3
		ld b, #24 ;Bright Yellow
		ld c, b
		call #0xBC32 ;SCR SET INK
	__endasm;

	//SCR SET BORDER 0
	__asm
		ld b, #0 ;black
		ld c, b
		call #0xBC38
	__endasm;

	//Init
	memset(aStars, 0, sizeof(aStars));

	for(nStar = 0; nStar < STARS_NUM; nStar++)
	{
		int nX = rand() % 3200 - 1600;
		int nY = rand() % 4000 - 2000;
		int nZ = MAX_Z;
		int nVelocity = 1 + rand() % 5;

		pStar = &aStars[nStar];
		pStar->nColor = GetMode0PixelColorByte(1 + rand() % 3, 0);
		
		for(nAddress = 0; nAddress < MAX_Z; nAddress++)
		{
			nScreenX = ORIGIN_X + nX / (nZ > 0 ? nZ : 1);
			nScreenY = ORIGIN_Y + nY / (nZ > 0 ? nZ : 1);

			if(nScreenX >= 0 && nScreenX < 160 && nScreenY >= 0 && nScreenY < 200)
			{
				pStar->aAddress[nAddress] = GetLineAddress(nScreenY) + (nScreenX / 2);
			}
			else
			{
				break;
			}

			nZ -= nVelocity;

			if(nZ < 0)
				break;
		}

		pStar->nActualAddress = rand() % nAddress;
	}

	nTimeLast = GetTime();

	while(1)
	{
		for(nStar = 0; nStar < STARS_NUM; nStar++)
		{
			pStar = &aStars[nStar];

			//delete star
			*pStar->aAddress[pStar->nActualAddress] = 0;

			//move star
			pStar->nActualAddress++;

			if(pStar->aAddress[pStar->nActualAddress] == NULL)
				pStar->nActualAddress = 0;
			
			//paint star
			*pStar->aAddress[pStar->nActualAddress] = pStar->nColor;
		}

		nFPS++;

		if(GetTime() - nTimeLast >= 300)
		{
			//TXT SET CURSOR 0,0
			__asm
				ld h, #1
				ld l, #1
				call #0xBB75
			__endasm;

			printf("%u  ", nFPS);

			nTimeLast = GetTime();
			nFPS = 0;
		}
	}
}
////////////////////////////////////////////////////////////////////////